Index: asterisk-1.8.11.1/channels/chan_sip.c
===================================================================
--- asterisk-1.8.11.1.orig/channels/chan_sip.c	2012-04-26 15:57:20.000000000 +0100
+++ asterisk-1.8.11.1/channels/chan_sip.c	2012-05-23 16:51:36.000000000 +0100
@@ -2709,7 +2709,14 @@
 				}
 
 				ast_mutex_lock(&tcptls_session->lock);
-				if (!fgets(buf, sizeof(buf), tcptls_session->f)) {
+				/* In SSL mode, data on the fd does not mean data is really ready! */
+if( after_poll && tcptls_session->ssl )
+	ast_verbose(VERBOSE_PREFIX_2 "ast_ssl_pending returns %d\n", ast_ssl_pending(tcptls_session->ssl));
+				if (after_poll && tcptls_session->ssl && !ast_ssl_pending(tcptls_session->ssl)) {
+					ast_mutex_unlock(&tcptls_session->lock);
+					need_poll = 1;
+					continue;
+				} else if (!fgets(buf, sizeof(buf), tcptls_session->f)) {
 					ast_mutex_unlock(&tcptls_session->lock);
 					if (after_poll) {
 						goto cleanup;
Index: asterisk-1.8.11.1/main/tcptls.c
===================================================================
--- asterisk-1.8.11.1.orig/main/tcptls.c	2012-04-26 15:57:20.000000000 +0100
+++ asterisk-1.8.11.1/main/tcptls.c	2012-05-23 12:42:46.000000000 +0100
@@ -97,6 +97,15 @@
 }
 #endif	/* DO_SSL */
 
+int ast_ssl_pending(void *cookie)
+{
+#ifdef DO_SSL
+	return SSL_pending(cookie);
+#else
+	return 0;
+#endif
+}
+
 HOOK_T ast_tcptls_server_read(struct ast_tcptls_session_instance *tcptls_session, void *buf, size_t count)
 {
 	if (tcptls_session->fd == -1) {
Index: asterisk-1.8.11.1/include/asterisk/tcptls.h
===================================================================
--- asterisk-1.8.11.1.orig/include/asterisk/tcptls.h	2012-04-26 17:58:32.000000000 +0100
+++ asterisk-1.8.11.1/include/asterisk/tcptls.h	2012-05-23 12:42:48.000000000 +0100
@@ -177,6 +177,13 @@
  */
 void ast_tcptls_close_session_file(struct ast_tcptls_session_instance *tcptls_session);
 
+/*! \brief
+ * replacement pending data check function for SSL support.
+ * We use wrappers rather than SSL_pending directly
+ * for consistency.
+ */
+int ast_ssl_pending(void *cookie);
+
 /*!
  * \brief This is a generic (re)start routine for a TCP server,
  * which does the socket/bind/listen and starts a thread for handling
